// Copyright (c) 2015, Mikhail Stolyarov. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

library do2template.base;

import 'dart:html';
import 'dart:async';

class Do2Template {

  List<Element> html;

  final String _html;

  static final NodeValidatorBuilder nodeValidator = new NodeValidatorBuilder.common()..allowElement('do2template');

  Do2Template clone(){
    return new Do2Template(_html);
  }

  Do2Template(String template): _html = template {
    Element do2template = new Element.html(_html, validator:nodeValidator);
    if(do2template.nodeName == 'DO2TEMPLATE'){
      html = do2template.children;
    }
    else{
      html = new List();
    }
  }

  static Future loadingHtml(Uri url){
    Completer<Do2Template> template = new Completer();
    HttpRequest.getString(url.toString()).then((String contentHtml){
      template.complete(new Do2Template(contentHtml));
    }).catchError((Error error) {
      print(error.toString());
      template.complete(new Do2Template('<do2template></do2template>'));
    });
    return template.future;
  }

}
