// Copyright (c) 2015, Mikhail Stolyarov. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

library do2template.test;

import 'dart:async';
import 'package:unittest/unittest.dart';
import 'package:do2template/do2template.dart';

main() {

  Do2Template.nodeValidator..allowElement('p', attributes:['role']);

  group('Do2Template', () {
    test('new Template', () {
      Do2Template template = new Do2Template('<do2template><div><p role="test">Hello</p></div></do2template>');
      expect(template.html[0].innerHtml, equals('<p role="test">Hello</p>'));
      Do2Template clon = template.clone();
      expect(clon.html[0].innerHtml, equals('<p role="test">Hello</p>'));
      expect(clon, isNot(same(template)));
    });

    test('test tr element',(){
      var complete = expectAsync((Do2Template template){
        expect(template.html[0].children[0].innerHtml, equals('hello'));
      });
      Do2Template.loadingHtml(Uri.parse('template/test.html')).then(complete);
    });
  });

}
